%% FIND DISTANCES

%Starting clock
tic

%% Imports the coordinate of each location

%chor_list is the coordinates of each location, Latitude, Longitude


%Select if distance between all farms should be calculated (reads from 
%Excel file):
%chor_list = xlsread('AnleggMH.xlsx','I2:J153');


%Select if distance between coordinates from natura_cluster_calc.m and 
%kmeans_calc.m should be used:
load('Allcoords.mat')
chor_list = Allcoords;

%% Generate distance matrix dimensions

%Generate the dimension of distance matrix 
dist=zeros(length(chor_list),length(chor_list));

%The c values checks between which location the code is running for
c = zeros(1,2);

%% Generate the distance matrix

%Generates the distance matrix by adding the coordinates of the locations
%to searoutes.com and  collects the sailing distance in the dist matrix.
%The distance is in nautical miles (nm)
%Since the matrix is symmetrical it only collects on side of the diagonal 

options=weboptions('Timeout',60);

for i=1:length(chor_list(:,1))
    c(1,1)=i;
    for j=1:length(chor_list(:,1))
        if i>=j
          dist(i,j)=0;
          c(1,2)=j
        else 
        page_url=['http://www.searoutes.com/routing/(' num2str(chor_list(i,1)) ',%20' num2str(chor_list(i,2)) ')/(' num2str(chor_list(j,1)) ',%20' num2str(chor_list(j,2)) ')' '?speed=13&panama=true&suez=true&kiel=true'] ;
        website=webread(page_url,options);
        loc=strfind(website,'"distance":');
        dist(i,j)=str2num(website(loc+11:loc+11+6));
        pause(0.5)
        c(1,2)=j
        end
    end
end

%% Make the distance matrix symmetrical along the diagonal

%Since the distance is symmetrical along the diagonal and one side only
%consists of zeros, this part flips the distance along the diagonal to get
%a symmetrical distance matrix.

for i=1:length(chor_list(:,1))
    for j=1:length(chor_list(:,1))
       dist2(j,i)=dist(i,j);
    end
end


%% Write the distance matrix

%Writes out the distance matrix 
dist=dist+dist2

%Stops the clock and display time used
toc
